<?php

namespace Database;
use Model\User;
use \PDO;
use \DateTime;
use Model\Role;
use Model\Coach;

class CoachMapper {
    public function coachSqlToEntity(array $data): array {
        $coachEntities = [];

        foreach ($data as $coachData) {
            $coach = new CoachEntity();

            if (isset($coachData['idCoach'])) {
                $coach->setIdCoach($coachData['idCoach']);
            }

            if (isset($coachData['athleteId'])) {
                $coach->setAthleteId($coachData['athleteId']);
            }

            $coachEntities[] = $athlete;
        }

        return $coachEntities;
    }

    public function CoachEntityToModel(CoachEntity $coachEntity):User{
        $role = new Coach();

        $dateSpecifique = $athleteEntity->getDateNaissance();
        $date = new DateTime($dateSpecifique);

        $user = new User(
            $coachEntity->getIdCoach(),
            //$coachEntity->getNom(),
            //$coachEntity->getPrenom(),
            //$coachEntity->getEmail(),
            //$coachEntity->getMotDePasse(),         //A MODIFIER : Doit recup les valeurs dans Athlete qui correspond
            //$coachEntity->getSexe(),
            //$coachEntity->getTaille(),
            //$coachEntity->getPoids(),
            //$coachEntity->getDateNaissance(),
            $date,
            $role
        );

        return $user;
    }

    public function CoachToEntity(User $user):CoachEntity{

        $coach = new CoachEntity();
        $coach->setIdCoach($user->getId());
        $coach->setAthleteId($user->getId());    //A MODIFIER !!! doit recup Id Athlete qui correspond

        return $coach;
    }
}

?>
